unit uMessages;
{$INCLUDE 'FRename3.inc'}

interface

uses
  {$IFDEF FAR3_UP} Plugin3, {$ELSE} PluginW, {$ENDIF} FarKeysW, FarColor,
  uSystem, uFAR, uLog,
  uFRenameConsts;

type
  TMessages = (
    MNoLngStringDefined = -1,
    MTitle = 0,
    MOK,
    MCancel,
    MRetry,
    MOverwrite,
    MSkip,
    MSkipAll,
    MFileListDescription,
    MFailedToOpenEditor,
    MFailedToLocateEditor,
    MFailedToLoadFileList,
    MSourceFileNotFound,
    MCantOverwriteDirectory,
    MFailedToRename,
    MFailedToRenameTo,
    MKeySelectDestinationFileNames,
    MKeySelectDestinationFileNamesLong,
    MKeyJumpToDestinationFileName,
    MKeyJumpToDestinationFileNameLong
  );

function GetMsg(MsgId: TMessages): PFarChar;
function GetMsgPas(MsgId: TMessages): string;
function FarMessage(const Msg: array of TMessages; Flags: TFarMessageFlags; ButtonCount: integer): integer;

implementation

const
  NO_MESSAGE = '';

function GetMsg(MsgId: TMessages): PFarChar;
begin
  if MsgId = MNoLngStringDefined then
    Result := NO_MESSAGE
  else
    Result := FarApi.GetMsg( {$IFDEF FAR3_UP} PLUGIN_GUID {$ELSE} FarApi.ModuleNumber {$ENDIF} , Integer(MsgId));
end;

function GetMsgPas(MsgId: TMessages): string;
begin
  Result := TFarUtils.CopyString(GetMsg(MsgId));
end;

function FarMessage(const Msg: array of TMessages; Flags: TFarMessageFlags; ButtonCount: integer): integer;
var
  RealMsg: array of PFarChar;
  i, n: integer;
begin
  n := Length(Msg);
  SetLength(RealMsg, n);
  for i := 0 to Pred(n) do
    RealMsg[i] := GetMsg(Msg[i]);
  Result := TFarUtils.ShowMessage(RealMsg, Flags, ButtonCount);
end;

end.
